package sample;

import java.io.IOException;

import org.apache.lucene.analysis.cjk.CJKAnalyzer;
import org.apache.lucene.document.Document;
import org.apache.lucene.document.Field;
import org.apache.lucene.document.Field.Index;
import org.apache.lucene.document.Field.Store;
import org.apache.lucene.index.CorruptIndexException;
import org.apache.lucene.index.IndexWriter;
import org.apache.lucene.store.LockObtainFailedException;

public class MakeIndex {

	private static final String[] TITLES = {
		"フロアー扇（業務用床置式扇風機）",
		"6インチ 車内用扇風機 カーファン",
		"MF-317HLR:フルリモコン＆マイナスイオン扇風機",
		"★大人気の新品リモコン付スリムファン【AS-750】 ",
		"大人気♪スリムファンマイコン・マイナスイオン:AS-700",
		"【1円～数量2】未使用B級品　40㎝リビング扇/扇風機　背高",
		"【PRIZ】新品☆マイナスイオン発生扇風機☆SANYO EF-30SM1",
		"100円スタート Lakewood ファン 扇風機 サーキュレーター 新品",
		"今回だけの特価ステン クラシカル扇風機（リモコン）",
		"（マイナスイオン付）プーさん卓上扇風機"
	};
	private static final String[] DESCRIPTIONS = {
		"フロアー扇(業務用床置式扇風機) アルミ４枚羽根(35cm)強力フロアー扇",
		"車内用のミニ扇風機です。人にさしあげる予定でこちらのオークションで落札したのですが、行き違いになってしまいました。私は車を持っていないので、どなたかにお譲りしたいと思います。",
		" マイナスイオン発生装置搭載の扇風機首振り自在のフルリモコン機能搭載！",
		"■消費電力 28W(50Hz)　33W(60Hz)■風量 17?/min　最大風速 330m/min　回転数 1232r/min■首振角度 約70度",
		"◆場所を選ばず置けるスリムな縦型扇風機◆強～弱の「リズム運転」とだんだんゆっくりになる　 「おやすみ運転」の２つのモード搭載！ ",
		"●広い部屋に広々風が送れる高さ最大約140㎝！●40㎝羽根で風量アップ！●事務所やリビングなど大きな部屋に最適●おしゃれなデザインでお部屋のイメージにもピッタリ！",
		"■低速ソフト風&天使の5枚羽根■お部屋に合わせて選べる高さ「セミハイポジション(71.5～96.0㎝まで伸縮)」■ 冷えすぎ防いでここちよい眠り「おやすみボタン」■天使の5枚羽根■コード収納ボックス",
		" こちらの商品は、100円スタートです！！こんなオシャレな扇風機が、なんと100円からっ！ぜひともこの機会をお見逃しなくっ！",
		" YAMAZENヤマゼン 30cm クラシカルハイリビング扇風機（リモコン）DF-1214R(SH) ステンヘアライン",
		"今年の夏は暑い！ プーさん　卓上扇風機（マイナスイオン付）子供部屋などに最適！小型で可愛いプーさんの扇風機です。"
	};
	private static final String F_TITLE = "title";
	private static final String F_DESC = "description";
	
	public static void main(String[] args) throws IOException {
		// 環境に合わせて以下にインデックスを置くディレクトリを指定してください
		final String INDEX = "C:/Project/work/index";
		IndexWriter writer = new IndexWriter( INDEX, new CJKAnalyzer() );
		for( int i = 0; i < TITLES.length; i++ ){
			Document doc = new Document();
			doc.add( new Field( F_TITLE, TITLES[i], Store.YES, Index.TOKENIZED ) );
			doc.add( new Field( F_DESC, DESCRIPTIONS[i], Store.YES, Index.TOKENIZED ) );
			writer.addDocument( doc );
		}
		writer.close();
	}
}
