<%@page contentType="text/html; charset=UTF-8"%>
<%@page import="java.io.IOException"%>
<%@page import="org.apache.lucene.analysis.Analyzer"%>
<%@page import="org.apache.lucene.analysis.cjk.CJKAnalyzer"%>
<%@page import="org.apache.lucene.document.Document"%>
<%@page import="org.apache.lucene.queryParser.QueryParser"%>
<%@page import="org.apache.lucene.search.Hits"%>
<%@page import="org.apache.lucene.search.IndexSearcher"%>
<%@page import="org.apache.lucene.search.Query"%>
<%@page import="org.apache.lucene.search.highlight.Highlighter"%>
<%@page import="org.apache.lucene.search.highlight.QueryScorer"%>
<%@page import="org.apache.lucene.search.highlight.Scorer"%>
<html>
<head>
<title>JBoss+Lucene demo</title>
</head>
<body>
<%!
private IndexSearcher searcher;
private Analyzer analyzer;
private final int PAGE_MAX = 10;
private final String FIELD = "description";

public void jspInit(){
	ServletConfig config = getServletConfig();
	String index = config.getInitParameter( "index" );
	try{
		searcher = new IndexSearcher( index );
	}
	catch( IOException e ){
		throw new RuntimeException( e );
	}
	analyzer = new CJKAnalyzer();
	System.out.println( "***** Lucene initialized successfully *****" );
}

public void jspDestroy(){
	try{
		if( searcher != null ) searcher.close();
	}
	catch( IOException e ){
		throw new RuntimeException( e );
	}	
	System.out.println( "***** Lucene destroyed successfully *****" );
}

private String getSummary( Query query, String text ) throws IOException {
	Scorer scorer = new QueryScorer( query, FIELD );
	Highlighter hl = new Highlighter( scorer );
	String fragment = hl.getBestFragment( analyzer, FIELD, text );
	return fragment == null ? "" : fragment;
}
%>

<p><b>Yahoo! オークション 商品検索</b></p>
<form action="search.jsp" method="GET">
	<input type="text" name="q"/><input type="submit" value="検索"/>
</form>

<%
request.setCharacterEncoding( "UTF-8" );
String q = request.getParameter( "q" );
if( q == null || q.length() == 0 ) return;
%>

検索式 = [ <b><%=q%></b> ]<br><br>

<%
QueryParser parser = new QueryParser( FIELD, analyzer );
Query query = parser.parse( q );
Hits hits = searcher.search( query );
int len = hits.length();
%>

ヒット件数 = <b><%=len%></b> 件<br><br>

<%
if( len == 0 ) return;
%>

<table border="1" cellspacing="0" cellpadding="2">
<% for( int i = 0; i < len && i < PAGE_MAX; i++ ){
	 Document doc = hits.doc( i );
	 float score = hits.score( i );
%>
<tr>
	<td><%= i + 1 %></td>
	<td><%= score %></td>
	<td><%= doc.get( "title" ) %></td>
</tr>
<tr>
	<td colspan="3"><%= getSummary( query, doc.get( FIELD ) ) %></td>
</tr>
<% } %>
</table>

</body>
</html>
